scoreboard players set @a 20 20
scoreboard players set @a 10 40

scoreboard players remove @a[scores={effect_t=0..}] effect_t 1
effect clear @a[tag=effect,scores={effect_t=..0},tag=!spectating]
tag @a[tag=effect,scores={effect_t=-1}] remove no_coords
tag @a[tag=effect,scores={effect_t=-1}] remove slime_block
tag @a[tag=effect,scores={effect_t=-1}] remove levitation
tag @a[tag=effect,scores={effect_t=-1}] remove jump_boost
tag @a[tag=effect,scores={effect_t=-1}] remove effect

execute as @a at @s if block ~ ~-1 ~ chiseled_quartz_block run function lh:check_effects
execute as @a at @s if block ~ ~-1 ~ slime_block run function lh:check_effects
execute as @a at @s if block ~ ~-1 ~ dark_oak_planks run function lh:check_effects

execute as @a at @s run scoreboard players operation @s effect_s = @s effect_t
execute as @a at @s run scoreboard players operation @s effect_s += @s 20
execute as @a at @s run scoreboard players operation @s effect_s /= @s 20

effect give @a[tag=effect,tag=levitation] levitation 10000 0 true
effect give @a[tag=effect,tag=slime_block] jump_boost 10000 1 true
effect give @a[tag=effect,tag=jump_boost] jump_boost 10000 0 true

execute as @a[tag=effect,tag=levitation] at @s run title @s actionbar ["",{"text":"CHISELED QUARTZ","bold":true,"color":"white"},{"text":" - ","color":"dark_gray"},{"text":"Gives levitation (","color":"gray"},{"score":{"name":"@s","objective":"effect_s"},"bold":true,"color":"gold"},{"text":"s","bold":true,"color":"gold"},{"text":")","color":"gray"}]
execute as @a[tag=effect,tag=slime_block] at @s run title @s actionbar ["",{"text":"SLIME BLOCK","bold":true,"color":"green"},{"text":" - ","color":"dark_gray"},{"text":"Gives jump boost (","color":"gray"},{"score":{"name":"@s","objective":"effect_s"},"bold":true,"color":"gold"},{"text":"s","bold":true,"color":"gold"},{"text":")","color":"gray"}]
execute as @a[tag=effect,tag=jump_boost] at @s run title @s actionbar ["",{"text":"DARK OAK PLANKS","bold":true,"color":"#964B00"},{"text":" - ","color":"dark_gray"},{"text":"Gives jump boost (","color":"gray"},{"score":{"name":"@s","objective":"effect_s"},"bold":true,"color":"gold"},{"text":"s","bold":true,"color":"gold"},{"text":")","color":"gray"}]

execute positioned 34 8 -34 if block ~ ~ ~ lever[powered=true] as @e[tag=switch,limit=1,sort=nearest] at @s run summon item ~ ~0.5 ~ {Tags:["clear","normal"],Item:{id:"minecraft:lever",Count:1b,tag:{tool:1,display:{Name:'[{"text":"","italic":false,"bold":false,"color":"white"},{"text":"Broken Lever","italic":false,"bold":true,"color":"blue"},{"text":"","italic":false,"bold":false,"color":"white"}]',Lore:['[{"text":"It seems to be missing a stand..."}]','[{"text":""}]','[{"text":"\\uE020\\uE020     Can be placed on:","italic":false,"color":"gray"}]','[{"text":"\\uE014 Purple Terracotta","italic":false,"color":"gray","bold":true}]']},HideFlags:127,CanPlaceOn:["minecraft:purple_terracotta"]}}}
execute positioned 34 8 -34 if block ~ ~ ~ lever[powered=true] if entity @e[type=marker,tag=switch,limit=1,sort=nearest,distance=..3] run particle minecraft:block minecraft:cobblestone ~ ~0.75 ~ 0.4 0.4 0.4 25 0
execute positioned 34 8 -34 if block ~ ~ ~ lever[powered=true] if entity @e[type=marker,tag=switch,limit=1,sort=nearest,distance=..3] run playsound minecraft:entity.ender_eye.death ambient @a ~ ~ ~ 1 0
execute positioned 34 8 -34 if block ~ ~ ~ lever[powered=true] if entity @e[type=marker,tag=switch,limit=1,sort=nearest,distance=..3] run setblock 16 4 3 minecraft:redstone_lamp[lit=true]

execute positioned 13 7 -13 if block ~ ~ ~ lever[powered=true] as @e[tag=switch,limit=1,sort=nearest] at @s run summon item ~ ~0.5 ~ {Tags:["clear","normal"],Item:{id:"minecraft:lever",Count:1b,tag:{tool:1,display:{Name:'[{"text":"","italic":false,"bold":false,"color":"white"},{"text":"Broken Lever","italic":false,"bold":true,"color":"blue"},{"text":"","italic":false,"bold":false,"color":"white"}]',Lore:['[{"text":"It seems to be missing a stand..."}]','[{"text":""}]','[{"text":"\\uE020\\uE020     Can be placed on:","italic":false,"color":"gray"}]','[{"text":"\\uE014 Purple Terracotta","italic":false,"color":"gray","bold":true}]']},HideFlags:127,CanPlaceOn:["minecraft:purple_terracotta"]}}}
execute positioned 13 7 -13 if block ~ ~ ~ lever[powered=true] if entity @e[type=marker,tag=switch,limit=1,sort=nearest,distance=..3] run particle minecraft:block minecraft:cobblestone ~ ~0.75 ~ 0.4 0.4 0.4 25 0
execute positioned 13 7 -13 if block ~ ~ ~ lever[powered=true] if entity @e[type=marker,tag=switch,limit=1,sort=nearest,distance=..3] run playsound minecraft:entity.ender_eye.death ambient @a ~ ~ ~ 1 0
execute positioned 13 7 -13 if block ~ ~ ~ lever[powered=true] if entity @e[type=marker,tag=switch,limit=1,sort=nearest,distance=..3] run setblock 18 4 3 minecraft:redstone_lamp[lit=true]

execute positioned 24 8 -3 if block ~ ~ ~ lever[powered=true] as @e[tag=switch,limit=1,sort=nearest] at @s run summon item ~ ~0.5 ~ {Tags:["clear","normal"],Item:{id:"minecraft:lever",Count:1b,tag:{tool:1,display:{Name:'[{"text":"","italic":false,"bold":false,"color":"white"},{"text":"Broken Lever","italic":false,"bold":true,"color":"blue"},{"text":"","italic":false,"bold":false,"color":"white"}]',Lore:['[{"text":"It seems to be missing a stand..."}]','[{"text":""}]','[{"text":"\\uE020\\uE020     Can be placed on:","italic":false,"color":"gray"}]','[{"text":"\\uE014 Purple Terracotta","italic":false,"color":"gray","bold":true}]']},HideFlags:127,CanPlaceOn:["minecraft:purple_terracotta"]}}}
execute positioned 24 8 -3 if block ~ ~ ~ lever[powered=true] if entity @e[type=marker,tag=switch,limit=1,sort=nearest,distance=..3] run particle minecraft:block minecraft:cobblestone ~ ~0.75 ~ 0.4 0.4 0.4 25 0
execute positioned 24 8 -3 if block ~ ~ ~ lever[powered=true] if entity @e[type=marker,tag=switch,limit=1,sort=nearest,distance=..3] run playsound minecraft:entity.ender_eye.death ambient @a ~ ~ ~ 1 0
execute positioned 24 8 -3 if block ~ ~ ~ lever[powered=true] if entity @e[type=marker,tag=switch,limit=1,sort=nearest,distance=..3] run setblock 20 4 3 minecraft:redstone_lamp[lit=true]

execute if block 34 8 -34 dead_horn_coral_fan run particle minecraft:electric_spark 25 8.5 -10.5 2 0.2 0.2 0.2 1
execute if block 34 8 -34 dead_horn_coral_fan run particle minecraft:electric_spark 17.5 8.5 0.5 0.2 0.2 4 0.2 2

execute if block 13 7 -13 dead_horn_coral_fan run particle minecraft:electric_spark 11.5 8.5 -3.5 0.2 0.2 2 0.2 1
execute if block 13 7 -13 dead_horn_coral_fan run particle minecraft:electric_spark 18.5 8.5 3.5 0.2 0.2 2 0.2 1

execute if block 24 8 -3 dead_horn_coral_fan run particle minecraft:electric_spark 25.5 6.5 -1.5 0.2 2 0.2 0.2 1
execute if block 24 8 -3 dead_horn_coral_fan run particle minecraft:electric_spark 19.5 8.5 3.5 0.2 0.2 2 0.2 1

execute as @e[type=marker,tag=switch] at @s if block ~ ~ ~ lever[powered=true] run tag @s add destroy
execute as @e[type=marker,tag=switch] at @s if block ~ ~ ~ lever[powered=true] run setblock ~ ~ ~ dead_horn_coral_fan[waterlogged=false]
execute as @e[type=marker,tag=switch] at @s if block ~ ~ ~ dead_horn_coral_fan[waterlogged=false] run setblock ~ ~2.5 ~ redstone_block
kill @e[type=marker,tag=destroy]


execute positioned 25.5 4.00 -16.5 if block ~ ~ ~ lever if block ~ ~-0.5 ~ purple_terracotta run setblock ~ ~ ~ lever[facing=north,face=floor]
execute positioned 24.5 4.00 -17.5 if block ~ ~ ~ lever if block ~ ~-0.5 ~ purple_terracotta run setblock ~ ~ ~ lever[facing=north,face=floor]
execute positioned 25.5 4.00 -18.5 if block ~ ~ ~ lever if block ~ ~-0.5 ~ purple_terracotta run setblock ~ ~ ~ lever[facing=north,face=floor]
execute positioned 25.5 4.00 -16.5 if block ~ ~ ~ lever if block ~ ~-0.5 ~ purple_terracotta run setblock ~ ~-0.5 ~ light_gray_terracotta
execute positioned 24.5 4.00 -17.5 if block ~ ~ ~ lever if block ~ ~-0.5 ~ purple_terracotta run setblock ~ ~-0.5 ~ light_gray_terracotta
execute positioned 25.5 4.00 -18.5 if block ~ ~ ~ lever if block ~ ~-0.5 ~ purple_terracotta run setblock ~ ~-0.5 ~ light_gray_terracotta

execute as @e[type=item] run data merge entity @s {Age:2}
execute as @e[type=item,tag=eye] at @s if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=end_cinematic_done] if entity @a[distance=..15] run data merge entity @s {Glowing:1b}
execute as @e[type=item,tag=eye] at @s if entity @e[type=marker,tag=orb_broken] unless entity @e[type=marker,tag=end_cinematic_done] run data merge entity @s {Glowing:1b}
execute as @e[type=item,tag=eye] at @s unless entity @e[tag=orb_broken] unless entity @a[distance=..15] run data merge entity @s {Glowing:0b}
execute as @e[type=item,tag=!static,tag=normal,tag=!eye] run data merge entity @s {PickupDelay:0}
execute as @e[type=item,tag=static,tag=!normal,tag=!eye] run data merge entity @s {PickupDelay:80}
execute as @e[type=item,tag=!normal,tag=!eye,tag=!static] at @s unless entity @a[distance=..5] at @p run teleport @s ~ ~0.5 ~
execute unless entity @e[tag=orb_broken] run execute as @e[type=item,tag=eye] run data merge entity @s {PickupDelay:100}

execute as @e[type=armor_stand,tag=door,tag=!deepslate,scores={position=0..150}] run item replace entity @s armor.head with kelp
execute as @e[type=armor_stand,tag=door,tag=!deepslate,scores={position=170}] run item replace entity @s armor.head with air
execute as @e[type=armor_stand,tag=door,tag=!deepslate,scores={position=-40}] run item replace entity @s armor.head with air
execute as @e[type=armor_stand,tag=door,tag=moving,tag=north_door,tag=descend,scores={position=0}] at @s run fill ~1 ~1.5 ~ ~-1 ~-1.5 ~ air replace iron_bars
execute as @e[type=armor_stand,tag=door,tag=moving,tag=south_door,tag=descend,scores={position=0}] at @s run fill ~ ~1.5 ~1 ~ ~-1.5 ~-1 air replace iron_bars
execute as @e[type=armor_stand,tag=door,tag=deepslate,tag=moving,tag=north_door,tag=descend,scores={position=0}] at @s run fill ~1 ~1.5 ~ ~-1 ~-1.5 ~ air replace barrier
execute as @e[type=armor_stand,tag=door,tag=deepslate,tag=moving,tag=south_door,tag=descend,scores={position=0}] at @s run fill ~ ~1.5 ~1 ~ ~-1.5 ~-1 air replace barrier

execute as @e[type=armor_stand,tag=door,tag=moving,scores={position=0..150}] at @s run function lh:set_position
scoreboard players add @e[type=armor_stand,tag=door,tag=!deepslate,tag=moving,tag=descend,scores={position=..160}] position 10
scoreboard players remove @e[type=armor_stand,tag=door,tag=!deepslate,tag=moving,tag=ascend,scores={position=-30..}] position 10
scoreboard players add @e[type=armor_stand,tag=door,tag=deepslate,tag=moving,tag=descend,scores={position=..160}] position 5
scoreboard players remove @e[type=armor_stand,tag=door,tag=deepslate,tag=moving,tag=ascend,scores={position=-30..}] position 5

execute as @e[type=armor_stand,tag=door,tag=!deepslate,tag=moving,scores={position=0..150}] at @s run playsound minecraft:entity.iron_golem.attack ambient @a ~ ~ ~ 0.5 0
execute as @e[type=armor_stand,tag=door,tag=deepslate,tag=moving,scores={position=0..150}] at @s run playsound minecraft:block.grindstone.use ambient @a ~ ~ ~ 1 1
execute as @e[type=armor_stand,tag=door,tag=!deepslate,tag=moving,tag=descend,scores={position=150}] at @s run playsound minecraft:entity.blaze.hurt ambient @a ~ ~ ~ 1 0
execute as @e[type=armor_stand,tag=door,tag=moving,tag=north_door,tag=ascend,scores={position=-40}] at @s run fill ~1 ~1.5 ~ ~-1 ~-1.5 ~ iron_bars replace air
execute as @e[type=armor_stand,tag=door,tag=moving,tag=south_door,tag=ascend,scores={position=-40}] at @s run fill ~ ~1.5 ~1 ~ ~-1.5 ~-1 iron_bars replace air
execute as @e[type=armor_stand,tag=door,tag=deepslate,tag=moving,tag=north_door,tag=ascend,scores={position=-40}] at @s run fill ~1 ~1.5 ~ ~-1 ~-1.5 ~ barrier replace air
execute as @e[type=armor_stand,tag=door,tag=deepslate,tag=moving,tag=south_door,tag=ascend,scores={position=-40}] at @s run fill ~ ~1.5 ~1 ~ ~-1.5 ~-1 barrier replace air
execute as @e[type=armor_stand,tag=door,tag=moving,tag=descend,scores={position=170}] at @s run tag @s remove moving
execute as @e[type=armor_stand,tag=door,tag=!deepslate,tag=moving,tag=ascend,scores={position=-10}] at @s run playsound minecraft:entity.blaze.hurt ambient @a ~ ~ ~ 1 0
execute as @e[type=armor_stand,tag=door,tag=moving,tag=ascend,scores={position=-40}] at @s run tag @s remove moving

tag @e[tag=!moving] remove ascend
tag @e[tag=!moving] remove descend

execute if block 25 4 -17 minecraft:lever[powered=true] positioned 25.34 4.00 -14.90 run function lh:descend
execute if block 24 4 -18 minecraft:lever[powered=true] positioned 22.61 4.00 -17.82 run function lh:descend
execute if block 25 4 -19 minecraft:lever[powered=true] positioned 25.34 4.00 -20.90 run function lh:descend
execute if block 25 4 -17 minecraft:lever[powered=false] positioned 25.34 4.00 -14.90 run function lh:ascend
execute if block 24 4 -18 minecraft:lever[powered=false] positioned 22.61 4.00 -17.82 run function lh:ascend
execute if block 25 4 -19 minecraft:lever[powered=false] positioned 25.34 4.00 -20.90 run function lh:ascend
execute unless entity @e[tag=button_door_closed] if block -3 5 -16 minecraft:redstone_lamp[lit=true] if block -3 5 -20 minecraft:redstone_lamp[lit=true] positioned -2.30 4.00 -17.46 run function lh:descend
execute unless entity @e[tag=button_door_open] unless block -3 5 -16 minecraft:redstone_lamp[lit=true] positioned -2.30 4.00 -17.46 run function lh:ascend
execute unless entity @e[tag=button_door_open] unless block -3 5 -20 minecraft:redstone_lamp[lit=true] positioned -2.30 4.00 -17.46 run function lh:ascend
execute if block -3 5 -16 minecraft:redstone_lamp[lit=true] if block -3 5 -20 minecraft:redstone_lamp[lit=true] positioned -2.30 4.00 -17.46 run tag @e[tag=variables] add button_door_closed
execute if block -3 5 -16 minecraft:redstone_lamp[lit=true] if block -3 5 -20 minecraft:redstone_lamp[lit=true] positioned -2.30 4.00 -17.46 run tag @e[tag=variables] remove button_door_open
execute unless block -3 5 -16 minecraft:redstone_lamp[lit=true] positioned -2.30 4.00 -17.46 run tag @e[tag=variables] add button_door_open
execute unless block -3 5 -20 minecraft:redstone_lamp[lit=true] positioned -2.30 4.00 -17.46 run tag @e[tag=variables] add button_door_open
execute unless block -3 5 -16 minecraft:redstone_lamp[lit=true] positioned -2.30 4.00 -17.46 run tag @e[tag=variables] remove button_door_closed
execute unless block -3 5 -20 minecraft:redstone_lamp[lit=true] positioned -2.30 4.00 -17.46 run tag @e[tag=variables] remove button_door_closed

execute if block -5 5 -18 lever if block -5 4 -18 minecraft:purple_terracotta run setblock -5 5 -18 lever[face=floor]
execute if block -5 5 -18 lever run setblock -5 4 -18 light_gray_terracotta

scoreboard players add @e[type=armor_stand,tag=chest,tag=opened] opening 1
execute as @e[type=armor_stand,tag=chest,limit=1,sort=nearest,scores={opening=1}] at @s as @e[tag=chest_hitbox,limit=4,sort=nearest] at @s run teleport @s ~ ~15 ~
execute as @e[type=armor_stand,tag=chest,limit=1,sort=nearest,scores={opening=1}] at @s positioned ~ ~15 ~ as @e[tag=chest_hitbox,limit=4,sort=nearest] at @s run kill @s
execute as @e[type=armor_stand,tag=chest,scores={opening=1}] at @s run playsound block.grindstone.use ambient @a ~ ~ ~ 1 1.5
execute as @e[type=armor_stand,tag=chest,scores={opening=1..5}] at @s as @e[tag=chest_top,limit=1,sort=nearest,distance=..3] at @s run teleport @s ~ ~0.075 ~
execute as @e[type=armor_stand,tag=chest,scores={opening=10}] at @s run playsound block.grindstone.use ambient @a ~ ~ ~ 1 1.5
execute as @e[type=armor_stand,tag=chest,scores={opening=10..20}] at @s as @e[tag=chest_top,limit=1,sort=nearest,distance=..3] at @s run teleport @s ^ ^ ^0.09
execute as @e[type=armor_stand,tag=chest,scores={opening=25}] at @s run playsound block.grindstone.use ambient @a ~ ~ ~ 1 1.5
execute as @e[type=armor_stand,tag=chest,scores={opening=25..35}] at @s as @e[tag=chest_top,limit=1,sort=nearest,distance=..3] at @s run teleport @s ~ ~-0.09405 ~
execute as @e[type=armor_stand,tag=chest,scores={opening=40}] at @s run playsound minecraft:entity.chicken.egg ambient @a ~ ~ ~ 1 0
execute as @e[type=armor_stand,tag=chest,scores={opening=40}] at @s run function lh:create_item
execute as @e[type=armor_stand,tag=chest,scores={opening=60..}] at @s run function lh:give_item

scoreboard players remove @e[type=armor_stand,tag=tomb,tag=opened] opening 1
execute as @e[type=armor_stand,tag=tomb,scores={opening=-1}] at @s run playsound block.grindstone.use ambient @a ~ ~ ~ 1 0
execute as @e[type=armor_stand,tag=tomb,scores={opening=-10..-1}] at @s as @e[tag=tomb_top,limit=1,sort=nearest,distance=..3] at @s run teleport @s ~ ~0.01 ~
execute as @e[type=armor_stand,tag=tomb,scores={opening=-20}] at @s run playsound block.grindstone.use ambient @a ~ ~ ~ 1 0
execute as @e[type=armor_stand,tag=tomb,scores={opening=-50..-20}] at @s as @e[tag=tomb_top,limit=1,sort=nearest,distance=..3] at @s run teleport @s ^-0.06 ^ ^
execute as @e[type=armor_stand,tag=tomb,scores={opening=-60}] at @s run playsound block.grindstone.use ambient @a ~ ~ ~ 1 0
execute as @e[type=armor_stand,tag=tomb,scores={opening=-80..-60}] at @s as @e[tag=tomb_top,limit=1,sort=nearest,distance=..3] at @s run teleport @s ~ ~-0.03 ~
execute unless entity @e[tag=ending] as @e[type=armor_stand,tag=tomb,scores={opening=-90}] at @s run playsound minecraft:entity.chicken.egg ambient @a ~ ~ ~ 1 0
execute unless entity @e[tag=ending] as @e[type=armor_stand,tag=tomb,scores={opening=-90}] at @s run summon item ~0.5 ~1 ~ {Motion:[0.0,0.2,0.0],PickupDelay:60,Tags:["clear","normal"],CustomName:'{"text":"Totem","color":"yellow"}',CustomNameVisible:1b,Item:{id:"minecraft:totem_of_undying",Count:1b,tag:{display:{Name:'[{"text":"","italic":false,"bold":false,"color":"white"},{"text":"Totem of Undying","italic":false,"bold":true,"color":"yellow"},{"text":"","italic":false,"bold":false,"color":"white"}]',Lore:['[{"text":""}]','[{"text":"YOU HAVE A SECOND LIFE","italic":false,"bold":true,"color":"gray"}]','[{"text":"Hold it in your offhand","italic":false,"color":"gray","bold":false}]']},HideFlags:127}}}
execute unless entity @e[tag=ending] as @e[type=armor_stand,tag=tomb,scores={opening=-90}] at @s run summon item ~-0.5 ~1 ~ {Motion:[0.0,0.2,0.0],PickupDelay:60,Tags:["clear","normal"],CustomName:'{"text":"Totem","color":"yellow"}',CustomNameVisible:1b,Item:{id:"minecraft:totem_of_undying",Count:1b,tag:{display:{Name:'[{"text":"","italic":false,"bold":false,"color":"white"},{"text":"Totem of Undying","italic":false,"bold":true,"color":"yellow"},{"text":"","italic":false,"bold":false,"color":"white"}]',Lore:['[{"text":""}]','[{"text":"YOU HAVE A SECOND LIFE","italic":false,"bold":true,"color":"gray"}]','[{"text":"Hold it in your offhand","italic":false,"color":"gray","bold":false}]']},HideFlags:127}}}


execute as @e[scores={opening=60..}] at @s if entity @a[distance=..1.5] if entity @e[type=item,tag=static,tag=!eye,distance=..1] at @e[type=item,tag=static,tag=!eye,distance=..1] run particle glow ~ ~0.25 ~ 0.2 0.2 0.2 0.1 10
execute as @e[scores={opening=60..}] at @s if entity @a[distance=..1.5] if entity @e[type=item,tag=static,tag=!eye,distance=..1] run kill @e[type=item,tag=static,tag=!eye,distance=..1]

execute if entity @e[type=marker,tag=water_humming] run playsound minecraft:item.trident.riptide_1 ambient @a 39.37 8.00 -1.55 0.5 0
execute if entity @e[type=marker,tag=water_flowing] run playsound minecraft:weather.rain.above ambient @a 39.37 8.00 -1.55 0.2 1
execute if entity @e[type=marker,tag=water_flowing] run particle falling_water 39.5 8.00 -1.5 0.1 0 0.1 0 2


execute if entity @a if entity @e[type=marker,tag=variables] unless entity @e[type=marker,tag=wrench_cinematic_done] if block 20 4 3 minecraft:redstone_lamp[lit=true] if block 18 4 3 minecraft:redstone_lamp[lit=true] if block 16 4 3 redstone_lamp[lit=true] run function lh:wrench_cinematic
execute if entity @a if entity @e[type=marker,tag=variables] unless entity @e[type=marker,tag=water_cinematic_done] if block 23 6 5 minecraft:stone_button[powered=true] run function lh:water_cinematic
execute if entity @a if entity @e[type=marker,tag=variables] unless entity @e[type=marker,tag=scroll_cinematic_done] if entity @a[scores={scroll=1..}] run function lh:scroll_cinematic

execute positioned 18.5 3.5 -17.5 run tag @a[distance=..1,tag=!teleportedd] add teleported
execute positioned 18.5 3.5 -17.5 run teleport @a[distance=..1,tag=!teleportedd] 18.50 4 -9.5 0 0
execute positioned 18.5 3.5 -8.5 run tag @a[distance=..1,tag=!teleported] add teleportedd
execute positioned 18.5 3.5 -8.5 run teleport @a[distance=..1,tag=!teleported] 19.5 4 -17.5 90 0


execute positioned 18.5 3.5 -17.5 run tag @a[distance=2..] remove teleportedd
execute positioned 18.5 3.5 -8.5 run tag @a[distance=2..] remove teleported

scoreboard players add @e[type=marker,tag=variables,scores={cinematic=0..}] cinematic 1

execute if entity @e[type=marker,tag=variables,scores={cinematic=0..}] run function lh:cinematic_checks



execute as @e[tag=checkpoint] if entity @e[type=marker,tag=game_started] run data merge entity @s {CustomNameVisible:1b}
execute as @e[tag=checkpoint] unless entity @e[type=marker,tag=game_started] run data merge entity @s {CustomNameVisible:0b}

gamemode spectator @a[tag=spectating]
execute as @a[tag=spectating] at @s run teleport @s @e[type=armor_stand,tag=cinematic,limit=1,sort=nearest]
execute as @a[tag=spectating] at @s run spectate @e[type=armor_stand,tag=cinematic,limit=1,sort=nearest] @s
effect give @a[tag=spectating] minecraft:levitation 2 255 true
effect give @a[tag=spectating] minecraft:invisibility 2 255 true
effect give @a[tag=spectating] minecraft:resistance 2 255 true
effect give @a saturation 1000000 255 true

execute if block 39 4 -39 lever[powered=true] positioned 39.66 4.00 -35.45 run function lh:descend
execute if block 39 4 -39 lever[powered=true] positioned 35.88 4.00 -38.59 run function lh:ascend
execute if block 39 4 -39 lever[powered=false] positioned 39.66 4.00 -35.45 run function lh:ascend
execute if block 39 4 -39 lever[powered=false] positioned 35.88 4.00 -38.59 run function lh:descend

execute unless block 32 4 -4 redstone_wire positioned 32.44 4.00 -0.26 run function lh:descend
execute unless block 32 4 -4 redstone_wire unless entity @e[tag=wrench_broken] run tellraw @a {"text":"Your wrench breaks...","color":"dark_gray"}
execute unless block 32 4 -4 redstone_wire unless entity @e[tag=wrench_broken] run execute at @a run playsound entity.item.break ambient @a ~ ~ ~ 0.5 1
execute unless block 32 4 -4 redstone_wire unless entity @e[tag=wrench_broken] run clear @a iron_axe
execute unless block 32 4 -4 redstone_wire unless entity @e[tag=wrench_broken] run tag @e[tag=variables] add wrench_broken

execute if block 4 4 -18 minecraft:red_terracotta if block 4 4 -25 pink_terracotta unless entity @e[tag=massive_pickaxe_broken] run tellraw @a {"text":"Your massive pickaxe breaks...","color":"dark_gray"}
execute if block 4 4 -18 minecraft:red_terracotta if block 4 4 -25 pink_terracotta unless entity @e[tag=massive_pickaxe_broken] run execute at @a run playsound entity.item.break ambient @a ~ ~ ~ 0.5 1
execute if block 4 4 -18 minecraft:red_terracotta if block 4 4 -25 pink_terracotta unless entity @e[tag=massive_pickaxe_broken] run clear @a stone_pickaxe
execute if block 4 4 -18 minecraft:red_terracotta if block 4 4 -25 pink_terracotta unless entity @e[tag=massive_pickaxe_broken] run tag @e[tag=variables] add massive_pickaxe_broken

execute if block 11 5 -3 lever[powered=false] positioned 12.37 3.00 -3.49 if entity @e[type=marker,tag=game_started] run execute at @e[type=armor_stand,tag=door,limit=3,sort=nearest] run function lh:ascend
execute if block 11 5 -3 lever[powered=true] positioned 12.37 3.00 -3.49 if entity @e[type=marker,tag=game_started] run execute at @e[type=armor_stand,tag=door,limit=3,sort=nearest] run function lh:descend

execute as @e[type=item,nbt={Item:{tag:{red_terracotta:1}}}] run data merge entity @s {Item:{id:"minecraft:red_terracotta",Count:1b,tag:{tool:1,display:{Name:'[{"text":"\\uE016 ","italic":false,"bold":false,"color":"white"},{"text":"Red Terracotta","italic":false,"bold":true,"color":"red"},{"text":" \\uE016 ","italic":false,"bold":false,"color":"white"}]',Lore:['[{"text":""}]','[{"text":"\\uE020\\uE020     Can be placed on:","italic":false,"color":"gray"}]','[{"text":"\\uE019 Polished Diorite","italic":false,"color":"gray","bold":true}]']},HideFlags:127,CanPlaceOn:["minecraft:polished_diorite"]}}}

execute as @e[type=item,nbt={Item:{tag:{pink_terracotta:1}}}] run data merge entity @s {Item:{id:"minecraft:pink_terracotta",Count:1b,tag:{tool:1,display:{Name:'[{"text":"\\uE017 ","italic":false,"bold":false,"color":"white"},{"text":"Pink Terracotta","italic":false,"bold":true,"color":"light_purple"},{"text":" \\uE017 ","italic":false,"bold":false,"color":"white"}]',Lore:['[{"text":""}]','[{"text":"\\uE020\\uE020     Can be placed on:","italic":false,"color":"gray"}]','[{"text":"\\uE018 Polished Granite","italic":false,"color":"gray","bold":true}]']},HideFlags:127,CanPlaceOn:["minecraft:polished_granite"]}}}

xp set @a 0 levels
xp set @a 0 points

kill @e[type=item,nbt={Item:{id:"minecraft:scute"}}]
kill @e[type=item,nbt={Item:{id:"minecraft:glow_berries"}}]
kill @e[type=item,nbt={Item:{id:"minecraft:oak_sign"}}]
execute at @e[type=item,tag=eye] run fill ~-7 ~-2 ~-7 ~7 ~7 ~7 air replace light
execute at @e[type=item,tag=eye] run fill ~ ~1 ~ ~ ~1 ~ light[level=7] replace air
execute at @e[tag=tracer] run teleport @e[type=turtle] ~ ~-84 ~
team join Eye @e[type=item,tag=eye]

execute as @e[tag=tracer,tag=north] at @s run teleport @s ~ ~ ~-0.05
execute as @e[tag=tracer,tag=south] at @s run teleport @s ~ ~ ~0.05
execute as @e[tag=tracer,tag=east] at @s run teleport @s ~0.05 ~ ~
execute as @e[tag=tracer,tag=west] at @s run teleport @s ~-0.05 ~ ~

execute as @e[tag=tracer] at @s if entity @e[tag=tracer_direction,distance=..0.04] run function lh:change_direction

#execute as @e[tag=tracer_direction] at @s run execute align xz positioned ~.5 ~ ~.5 run teleport @s ~ ~ ~ 
#execute as @e[tag=tracer_direction] at @s run execute if block ~ ~-1 ~ minecraft:magenta_glazed_terracotta[facing=west] run tag @s add east
#execute as @e[tag=tracer_direction] at @s run execute if block ~ ~-1 ~ minecraft:magenta_glazed_terracotta[facing=north] run tag @s add south
#execute as @e[tag=tracer_direction] at @s run execute if block ~ ~-1 ~ minecraft:magenta_glazed_terracotta[facing=east] run tag @s add west
#execute as @e[tag=tracer_direction] at @s run execute if block ~ ~-1 ~ minecraft:magenta_glazed_terracotta[facing=south] run tag @s add north

execute if entity @e[type=marker,tag=game_started] run execute as @a[scores={totem=1}] run advancement grant @s only lh:lh/not_today
clear @a minecraft:glass_bottle
execute if entity @e[type=marker,tag=game_started] run execute as @a[scores={tmp=350}] run advancement grant @s only lh:lh/trigger_happy_havoc
execute as @a run scoreboard players operation @s tmp = @s brown_mushroom
execute as @a run scoreboard players operation @s tmp += @s mushroom_stem
execute as @a run scoreboard players operation @s tmp += @s packed_ice
execute as @a run scoreboard players operation @s tmp += @s coarse_dirt
execute as @a run scoreboard players operation @s tmp += @s cobweb
execute as @a run scoreboard players operation @s tmp += @s redstone_wire
execute as @a run scoreboard players operation @s tmp += @s crying_obsidian
execute as @a run scoreboard players operation @s tmp += @s ice

execute if block 3 3 -22 minecraft:birch_button[powered=true] unless entity @e[type=marker,tag=2nd_button_cinematic_done] if entity @a if entity @e[type=marker,tag=variables] run function lh:2nd_button_cinematic
execute if block 3 3 -22 minecraft:birch_button[powered=true] if entity @e[type=marker,tag=2nd_button] run setblock -3 5 -21 redstone_block
execute if block 3 3 -22 minecraft:birch_button[powered=false] run setblock -3 5 -21 air

execute if block 32 6 -39 minecraft:birch_button[powered=true] unless entity @e[type=marker,tag=1st_button_cinematic_done] if entity @a if entity @e[type=marker,tag=variables] run function lh:1st_button_cinematic 
execute if block 32 6 -39 minecraft:birch_button[powered=true] if entity @e[type=marker,tag=1st_button] run setblock -3 5 -15 redstone_block
execute if block 32 6 -39 minecraft:birch_button[powered=false] run setblock -3 5 -15 air

execute if block 37 1 -23 lever[powered=true] unless entity @e[type=marker,tag=1st_lever_cinematic_done] if entity @a if entity @e[type=marker,tag=variables] run function lh:1st_lever_cinematic
execute if block 37 1 -23 lever[powered=true] if entity @e[type=marker,tag=1st_lever] run setblock -8 2 3 redstone_block

execute if block 5 1 -37 lever[powered=true] unless entity @e[type=marker,tag=2nd_lever_cinematic_done] if entity @a if entity @e[type=marker,tag=variables] run function lh:2nd_lever_cinematic
execute if block 5 1 -37 lever[powered=true] if entity @e[type=marker,tag=2nd_lever] run setblock -10 2 5 redstone_block

execute if block -5 5 -18 lever[powered=true] unless entity @e[type=marker,tag=3rd_lever_cinematic_done] if entity @a if entity @e[type=marker,tag=variables] run function lh:3rd_lever_cinematic
execute if block -5 5 -18 lever[powered=true] if entity @e[type=marker,tag=3rd_lever] run setblock -12 2 3 minecraft:redstone_block

execute if entity @e[type=marker,tag=cp3_reached] unless entity @e[tag=armor] unless entity @e[type=marker,tag=secret_cinematic_done] if entity @a if entity @e[type=marker,tag=variables] run function lh:secret_cinematic
execute unless entity @e[tag=armor] unless entity @e[type=marker,tag=secret_cinematic_done] run tag @e[tag=variables] add secret_cinematic_done

execute if block 2 5 5 stone_button[powered=true] positioned 4.36 4.00 7.25 run function lh:descend
execute if block 2 5 5 stone_button[powered=false] positioned 4.36 4.00 7.25 run function lh:ascend


execute if block -3 2 -23 redstone_block run effect give @e[type=armor_stand,tag=armor] glowing 500000
execute if block -3 2 -23 redstone_block run tellraw @a ["",{"text":"\n"},{"text":"Destroy every armor stand to open a secret room...","italic":true,"color":"dark_purple"},{"text":"\n "}]
execute if block -3 2 -23 redstone_block run setblock -3 2 -23 air

execute as @a[tag=!inventory_stored] at @s run clear @s warped_fungus_on_a_stick{checkpoint:1}
execute as @a[tag=inventory_stored] at @s unless entity @s[nbt={Inventory:[{Slot:0b,id:"minecraft:warped_fungus_on_a_stick",tag:{teleporter_used:1}},{Slot:2b,id:"minecraft:warped_fungus_on_a_stick",tag:{checkpoint:1}},{Slot:3b,id:"minecraft:warped_fungus_on_a_stick",tag:{checkpoint:1}},{Slot:4b,id:"minecraft:warped_fungus_on_a_stick",tag:{checkpoint:1}},{Slot:5b,id:"minecraft:warped_fungus_on_a_stick",tag:{checkpoint:1}},{Slot:6b,id:"minecraft:warped_fungus_on_a_stick",tag:{checkpoint:1}}]}] run function lh:take_inventory

title @a[nbt={SelectedItem:{tag:{checkpoint:1}}}] times 0 5 0
title @a[nbt={SelectedItem:{tag:{cp1:1}}}] title [{"text":"CHECKPOINT 1","bold":true,"color":"gold","italic":false},{"text":" ","italic":false},{"text":"","italic":false,"color":"dark_gray"},{"text":"","italic":false,"color":"gray","bold":false}]
title @a[nbt={SelectedItem:{tag:{cp2:1}}}] title [{"text":"CHECKPOINT 2","bold":true,"color":"gold","italic":false},{"text":" ","italic":false},{"text":"","italic":false,"color":"dark_gray"},{"text":"","italic":false,"color":"gray","bold":false}]
title @a[nbt={SelectedItem:{tag:{cp3:1}}}] title [{"text":"CHECKPOINT 3","bold":true,"color":"gold","italic":false},{"text":" ","italic":false},{"text":"","italic":false,"color":"dark_gray"},{"text":"","italic":false,"color":"gray","bold":false}]
title @a[nbt={SelectedItem:{tag:{cp4:1}}}] title [{"text":"CHECKPOINT 4","bold":true,"color":"gold","italic":false},{"text":" ","italic":false},{"text":"","italic":false,"color":"dark_gray"},{"text":"","italic":false,"color":"gray","bold":false}]
title @a[nbt={SelectedItem:{tag:{cp5:1}}}] title [{"text":"CHECKPOINT 5","bold":true,"color":"gold","italic":false},{"text":" ","italic":false},{"text":"","italic":false,"color":"dark_gray"},{"text":"","italic":false,"color":"gray","bold":false}]
title @a[nbt={SelectedItem:{tag:{nocp:1}}}] title [{"text":"Checkpoint not unlocked","bold":true,"color":"red","italic":false},{"text":" ","italic":false},{"text":"","italic":false,"color":"dark_gray"},{"text":"","italic":false,"color":"gray","bold":false}]

execute as @a[scores={teleporter=1..},nbt={SelectedItem:{tag:{teleporter_unused:1}}},tag=!inventory_stored] at @s run function lh:store_inventory
execute as @a[scores={teleporter=1..},nbt={SelectedItem:{tag:{teleporter_used:1}}}] at @s run function lh:take_inventory
execute as @a[scores={teleporter=1..},nbt={SelectedItem:{tag:{cp1:1}}}] at @s run teleport @s @e[tag=cp1,limit=1]
execute as @a[scores={teleporter=1..},nbt={SelectedItem:{tag:{cp2:1}}}] at @s run teleport @s @e[tag=cp2,limit=1]
execute as @a[scores={teleporter=1..},nbt={SelectedItem:{tag:{cp3:1}}}] at @s run teleport @s @e[tag=cp3,limit=1]
execute as @a[scores={teleporter=1..},nbt={SelectedItem:{tag:{cp4:1}}}] at @s run teleport @s @e[tag=cp4,limit=1]
execute as @a[scores={teleporter=1..},nbt={SelectedItem:{tag:{cp5:1}}}] at @s run teleport @s @e[tag=cp5,limit=1]
execute as @a[scores={teleporter=1..},nbt={SelectedItem:{tag:{checkpoint:1}}}] at @s run function lh:take_inventory
execute as @a[scores={teleporter=1..}] at @s run tag @s remove storing
scoreboard players set @a teleporter 0

execute if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=cp1_reached] as @e[type=armor_stand,tag=cp1] at @s if entity @a[distance=..1] run advancement grant @a only lh:lh/checkpoint_1
execute if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=cp1_reached] as @e[type=armor_stand,tag=cp1] at @s if entity @a[distance=..1] run setworldspawn ~ ~ ~
execute if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=cp1_reached] as @e[type=armor_stand,tag=cp1] at @s if entity @a[distance=..1] run playsound entity.arrow.hit_player ambient @a ~ ~ ~ 1 1
execute if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=cp1_reached] as @e[type=armor_stand,tag=cp1] at @s if entity @a[distance=..1] run give @a minecraft:writable_book{display:{Name:'{"text":"Notebook","italic":false}'}}
execute if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=cp1_reached] as @e[type=armor_stand,tag=cp1] at @s if entity @a[distance=..1] run tag @e[tag=variables] add cp1_reached

execute if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=cp2_reached] as @e[type=armor_stand,tag=cp2] at @s if entity @a[distance=..1] run advancement grant @a only lh:lh/checkpoint_2
execute if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=cp2_reached] as @e[type=armor_stand,tag=cp2] at @s if entity @a[distance=..1] run setworldspawn ~ ~ ~
execute if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=cp2_reached] as @e[type=armor_stand,tag=cp2] at @s if entity @a[distance=..1] run playsound entity.arrow.hit_player ambient @a ~ ~ ~ 1 1
execute if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=cp2_reached] as @e[type=armor_stand,tag=cp2] at @s if entity @a[distance=..1] run tellraw @a ["",{"text":"\n"},{"text":"CHECKPOINT 2 REACHED!","bold":true,"color":"yellow"},{"text":"\n"},{"text":"-Use the book for fast travel-","color":"blue"},{"text":"\n "}]
execute if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=cp2_reached] as @e[type=armor_stand,tag=cp2] at @s if entity @a[distance=..1] run tag @e[tag=variables] add cp2_reached

execute if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=cp3_reached] as @e[type=armor_stand,tag=cp3] at @s if entity @a[distance=..1] run advancement grant @a only lh:lh/checkpoint_3
execute if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=cp3_reached] as @e[type=armor_stand,tag=cp3] at @s if entity @a[distance=..1] run setworldspawn ~ ~ ~
execute if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=cp3_reached] as @e[type=armor_stand,tag=cp3] at @s if entity @a[distance=..1] run playsound entity.arrow.hit_player ambient @a ~ ~ ~ 1 1
execute if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=cp3_reached] as @e[type=armor_stand,tag=cp3] at @s if entity @a[distance=..1] run tellraw @a ["",{"text":"\n"},{"text":"CHECKPOINT 3 REACHED!","bold":true,"color":"yellow"},{"text":"\n"},{"text":"-Use the book for fast travel-","color":"blue"},{"text":"\n "}]
execute if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=cp3_reached] as @e[type=armor_stand,tag=cp3] at @s if entity @a[distance=..1] run tag @e[tag=variables] add cp3_reached

execute if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=cp4_reached] as @e[type=armor_stand,tag=cp4] at @s if entity @a[distance=..1] run advancement grant @a only lh:lh/checkpoint_4
execute if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=cp4_reached] as @e[type=armor_stand,tag=cp4] at @s if entity @a[distance=..1] run setworldspawn ~ ~ ~
execute if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=cp4_reached] as @e[type=armor_stand,tag=cp4] at @s if entity @a[distance=..1] run playsound entity.arrow.hit_player ambient @a ~ ~ ~ 1 1
execute if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=cp4_reached] as @e[type=armor_stand,tag=cp4] at @s if entity @a[distance=..1] run tellraw @a ["",{"text":"\n"},{"text":"CHECKPOINT 4 REACHED!","bold":true,"color":"yellow"},{"text":"\n"},{"text":"-Use the book for fast travel-","color":"blue"},{"text":"\n "}]
execute if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=cp4_reached] as @e[type=armor_stand,tag=cp4] at @s if entity @a[distance=..1] run tag @e[tag=variables] add cp4_reached

execute if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=cp5_reached] as @e[type=armor_stand,tag=cp5] at @s if entity @a[distance=..1] run advancement grant @a only lh:lh/checkpoint_5
execute if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=cp5_reached] as @e[type=armor_stand,tag=cp5] at @s if entity @a[distance=..1] run setworldspawn ~ ~ ~
execute if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=cp5_reached] as @e[type=armor_stand,tag=cp5] at @s if entity @a[distance=..1] run playsound entity.arrow.hit_player ambient @a ~ ~ ~ 1 1
execute if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=cp5_reached] as @e[type=armor_stand,tag=cp5] at @s if entity @a[distance=..1] run tellraw @a ["",{"text":"\n"},{"text":"CHECKPOINT 5 REACHED!","bold":true,"color":"yellow"},{"text":"\n"},{"text":"-Use the book for fast travel-","color":"blue"},{"text":"\n "}]
execute if entity @e[type=marker,tag=game_started] unless entity @e[type=marker,tag=cp5_reached] as @e[type=armor_stand,tag=cp5] at @s if entity @a[distance=..1] run tag @e[tag=variables] add cp5_reached

execute unless entity @e[type=marker,tag=end_cinematic_done] unless entity @e[tag=orb_broken] unless block 18 5 10 minecraft:crying_obsidian run advancement grant @a only lh:lh/free_the_halls
execute unless entity @e[type=marker,tag=end_cinematic_done] unless entity @e[tag=orb_broken] unless block 18 5 10 minecraft:crying_obsidian run playsound minecraft:entity.ender_dragon.death ambient @a ~ ~ ~ 10 0
execute unless entity @e[type=marker,tag=end_cinematic_done] unless entity @e[tag=orb_broken] unless block 18 5 10 minecraft:crying_obsidian run tellraw @a ["",{"text":"\n"},{"text":"Screams are echoing in the lost halls...\n...the Eye lost its defensive powers!","italic":true,"color":"dark_purple"},{"text":"\n\n"},{"text":"Catch the eye and bring it to the portal frame!","color":"gold"},{"text":"\n "}]
execute unless entity @e[type=marker,tag=end_cinematic_done] unless entity @e[tag=orb_broken] unless block 18 5 10 minecraft:crying_obsidian run tag @e[tag=variables] add orb_broken
execute unless entity @e[type=marker,tag=end_cinematic_done] unless block 18 5 10 minecraft:crying_obsidian at @e[type=shulker] run kill @e[type=armor_stand,tag=orb_glow_stand]
execute unless entity @e[type=marker,tag=end_cinematic_done] unless block 18 5 10 minecraft:crying_obsidian at @e[type=shulker] run teleport @e[type=shulker,limit=1,sort=nearest] ~ ~5 ~
execute unless entity @e[type=marker,tag=end_cinematic_done] unless block 18 5 10 minecraft:crying_obsidian at @e[type=shulker] run effect clear @e[type=shulker] glowing
execute unless entity @e[type=marker,tag=end_cinematic_done] unless block 18 5 10 minecraft:crying_obsidian positioned 18 52 10 run kill @e[type=shulker,distance=..10]
execute unless entity @e[type=marker,tag=end_cinematic_done] if block 18 5 10 minecraft:crying_obsidian run particle minecraft:crimson_spore 18.5 5.5 10.5 2 2 2 0 10

execute unless entity @e[tag=code_entered] if entity @e[tag=digit_1,scores={digit=5}] if entity @e[tag=digit_2,scores={digit=2}] if entity @e[tag=digit_3,scores={digit=9}] if entity @e[tag=digit_4,scores={digit=4}] run function lh:code_entered

execute as @a at @s positioned ~ -5 ~ run kill @s[distance=..2,gamemode=adventure]
title @a[tag=inventory_stored] actionbar {"text":"Right click the book to close the teleportation hud","color":"red"}
execute as @e[type=marker,tag=room] at @s positioned ~-3.5 ~10 ~-3.5 run title @a[dz=5.75,dx=5.75,dy=-20,tag=!no_coords,tag=!inventory_stored] actionbar ["",{"score":{"name":"@s","objective":"room_x"}},{"text":" ; "},{"score":{"name":"@s","objective":"room_y"}}]
execute as @e[type=marker,tag=room,tag=power,tag=!removed] at @s positioned ~-3.5 ~10 ~-3.5 if entity @a[dz=5.75,dx=5.75,dy=-20,tag=!spectating] run bossbar set minecraft:power visible true
execute as @e[type=marker,tag=room,tag=buttons,tag=!removed] at @s positioned ~-3.5 ~10 ~-3.5 if entity @a[dz=5.75,dx=5.75,dy=-20,tag=!spectating] run bossbar set minecraft:buttons visible true
execute as @e[type=marker,tag=room,tag=levers,tag=!removed] at @s positioned ~-3.5 ~10 ~-3.5 if entity @a[dz=5.75,dx=5.75,dy=-20,tag=!spectating] run bossbar set minecraft:levers visible true

execute positioned 39.36 4.00 4.59 if entity @a[distance=..3] positioned 36.60 4.00 3.53 run function lh:descend
advancement grant @a[scores={totem=1..}] only lh:lh/not_today

bossbar set minecraft:power players @a
bossbar set minecraft:levers players @a
bossbar set minecraft:buttons players @a

execute if block -5 5 -18 lever run bossbar set minecraft:buttons visible false
execute if block -5 5 -18 lever run tag @e[tag=buttons] add removed


execute if entity @e[type=armor_stand,tag=deepslate,tag=moving] run tag @e[tag=levers] add removed
execute if entity @e[type=armor_stand,tag=deepslate,tag=moving] run bossbar set minecraft:levers visible false
execute if entity @e[type=armor_stand,tag=deepslate,tag=moving] run advancement grant @a only lh:lh/lever_hunter

execute if entity @e[type=armor_stand,tag=code_entered] run advancement grant @a only lh:lh/ancient_knowledge

execute if block 52 4 -10 minecraft:end_portal_frame[eye=true] run playsound minecraft:particle.soul_escape ambient @a 52.5 4.8 -9.5 1 0.5
execute if block 52 4 -10 minecraft:end_portal_frame[eye=false] run playsound minecraft:particle.soul_escape ambient @a 52.5 4.8 -9.5 1 1
execute if block 52 4 -10 minecraft:end_portal_frame[eye=true] run particle minecraft:smoke 52.5 5 -9.5 0 0 0 0 1
execute if block 52 4 -10 minecraft:end_portal_frame[eye=true] unless entity @e[tag=eye_placed] run scoreboard players set @e[tag=variables] cinematic 19850 
execute if block 52 4 -10 minecraft:end_portal_frame[eye=true] unless entity @e[tag=eye_placed] run tag @e[tag=variables] add eye_placed

execute if block 68 81 -1009 lever if block 68 80 -1009 purple_terracotta run setblock 68 81 -1009 lever[face=floor]
execute if block 68 81 -1009 lever run setblock 68 80 -1009 light_gray_terracotta

execute as @e[tag=big_start_button] if block 50 81 -1003 crimson_button[powered=true] run data merge entity @e[tag=button_text,limit=1] {CustomName:'{"text":"Starting...","color":"red"}'}
execute as @e[tag=big_start_button] if block 50 81 -1003 crimson_button[powered=true] run execute as @e[tag=big_start_button] at @s run item replace entity @s armor.head with wooden_axe
execute as @e[tag=big_start_button] if block 50 81 -1003 crimson_button[powered=true] run execute as @e[tag=big_start_button] at @s run teleport @s ~-0.5 ~ ~
execute as @e[tag=big_start_button] if block 50 81 -1003 crimson_button[powered=true] run execute as @e[tag=big_start_button] at @s run playsound minecraft:block.grindstone.use ambient @a ~ ~ ~ 1 0.5
execute as @e[tag=big_start_button] if block 50 81 -1003 crimson_button[powered=true] run function lh:start
execute as @e[tag=big_start_button] if block 50 81 -1003 crimson_button[powered=true] run fill 49 80 -1004 49 82 -1002 barrier
execute as @e[tag=big_start_button] if block 50 81 -1003 crimson_button[powered=true] run setblock 50 81 -1003 air

execute unless entity @e[type=marker,tag=game_started] run teleport @a[tag=!entered] 92 80 -1007 0 0
execute if entity @e[type=marker,tag=game_started] run teleport @a[tag=!entered] 46.5 4 -10.5
execute if entity @e[type=marker,tag=game_started] as @a[tag=!entered] at @s run function lh:get_stuff
execute if entity @e[type=marker,tag=game_started] as @a[tag=!entered] at @s run function lh:add_tag
team join here @a[tag=!entered]
gamemode adventure @a[tag=!entered]
tag @a add entered

execute if entity @e[type=marker,tag=variables,scores={cinematic=..-100}] run tag @a remove spectating

execute if entity @e[tag=cp1_reached] run give @a[tag=!has_book] minecraft:warped_fungus_on_a_stick{teleporter_unused:1,CustomModelData:10,HideFlags:127,display:{Lore:['[{"text":"","italic":true,"color":"dark_red","bold":true},{"text":"","bold":false}]'],Name:'[{"text":"TELEPORTER","bold":true,"color":"gold","italic":false},{"text":" ","italic":false},{"text":"- ","italic":false,"color":"dark_gray"},{"text":"Right-click to use","italic":false,"color":"gray","bold":false}]'},Unbreakable:1}
execute if entity @e[tag=cp1_reached] run tag @a add has_book
